#ifndef lint
static char SCCSid[] = "@(#) ./comm/io/piunix.c 12/01/93";
#endif

#include <stdio.h>
#include <ctype.h>
#if defined(cray)
#include <errno.h>
#else
extern int errno;
#endif
#include <sys/errno.h>
#include "tools.h"
#include "comm/comm.h"
#include "comm/io/pio.h"
#ifndef SEEK_SET
#include <unistd.h>
#endif

/* #if !defined(rs6000) */
extern int lseek();
/* #endif */

extern int read(), write();

#if defined(intelparagon)
extern long _cread(), _cwrite();
#elif defined(intelnx)
extern int cread(), cwrite();
#endif

/* 
   Default read, write, and seek routines.  These are simple versions
   of read, write, and lseek, but they take a PIFILE instead of an fd.
   This allows us to replace these routines with cached varieties.

   They ALSO handle EINTR
 */
int PIiDefRead( fp, buffer, len )
PIFILE *fp;
char   *buffer;
int    len;
{
int err;

#if defined(intelnx)
err = cread( fp->fd, buffer, len );
#else
while (1) {
    err = read( fp->fd, buffer, len );
    if (err < 0 && errno == EINTR) continue;
    if (err < 0) {
	SETERRC( 1, "Error in reading from file" );
	return -1;
	}
    break;
    }
#endif
return err;
}

int PIiDefWrite( fp, buffer, len )
PIFILE *fp;
char   *buffer;
int    len;
{
int err;

#if defined(intelnx)
err = cwrite( fp->fd, buffer, len );
#else
while (1) {
    err = write( fp->fd, buffer, len );
    if (err < 0 && errno == EINTR) continue;
    if (err != len) {
	SETERRC( 1, "Error in writing to file" );
	return -1;
	}
    break;
    }
#endif
return err;
}
int PIiDefFlush( fp )
PIFILE *fp;
{
return 0;
}
int PIiDefLseek( fp, offset, whence, rw )
PIFILE *fp;
int    offset, whence, rw;
{
lseek( fp->fd, offset, whence );
}

int PIiDefClose( fp )
PIFILE *fp;
{
close( fp->fd );
}
