#include "tools.h"
#include "dgraph/dgraph.h"

void DrawNode( gctx, xc, yc, num )
GRctx *gctx;
int  xc, yc, num;
{
char snum[5];	
GRStyle style;


sprintf( snum, "%d", num );
GRDrawText( gctx, (double)xc, (double)yc, snum, 10, GRCENTER ); 
style.line_style = GRSOLID;
style.color      = GRBLACK;
GRDrawRectangle( gctx, (double) (xc - 2), (double) (xc + 2),
		       (double) (yc - 2), (double) (yc + 2), &style );
}

/* type == 0 for in range, 1 otherwise */
void DrawConnection( gctx, fromx, fromy, tox, toy, type )
GRctx *gctx;
int  fromx, fromy, tox, toy, type;
{
GRStyle style;
style.line_style = type ? GRSOLID : GRDASH;
style.color      = type ? GRBLACK : GRRED;
GRDrawLine( gctx, (double)fromx, (double)fromy, (double)tox, (double)toy,
	    &style );
}

main( argc, argv )
int  argc;
char **argv;
{
int          i, k, c;
GRctx        *gctx;
/* int          np = 16; */
int          np = 2;

gctx = GRCreateFromArgs( &argc, argv );

GRStartPage( gctx );	
GRSetLimits( gctx, -3.0, (double)(np * 5), -1.0, 15.0 );
GRDrawAxis( gctx, 0 );
for (i=0; i<np; i++) {
    DrawNode( gctx, i*5, 2,  i );
    DrawNode( gctx, i*5, 12, i );
    }
for (i=0; i<np; i++) {
    for (k=0; k<np; k++) {
	if (k != i) 
	    DrawConnection( gctx, i*5, 4, k*5, 10, k & 0x1 );
        }
    }

GREndPage( gctx );    

printf( "Press return to end program..." );
c = getc( stdin );
}
